<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleIMUTracking_answers.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleIMUTracking_answers_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleIMUTracking_answers.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that uses a squat-to-stand motion to create synthetic accelerometer data, and then creates a tracking simulation to track the synthetic accelerometer signals.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> exampleIMUTracking_helpers <span class="keyword">as</span> helpers</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Add the directory above to access mocoPlotTrajectory.py</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">import</span> sys</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;sys.path.insert(1, <span class="stringliteral">&#39;../&#39;</span>)</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">import</span> mocoPlotTrajectory <span class="keyword">as</span> plot</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">import</span> numpy <span class="keyword">as</span> np</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;model = helpers.getTorqueDrivenSquatToStandModel()</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># Part 1b: Add frames to the model that will represent our IMU locations. </span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"># The function addIMUFrame() adds a PhysicalOffsetFrame to a body at a </span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># specified location and orientation. Each frame is added at the path:</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># /bodyset/&lt;body_name&gt;/&lt;body_name&gt;_imu_offset</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;helpers.addIMUFrame(model, <span class="stringliteral">&#39;torso&#39;</span>, </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    osim.Vec3(0.08, 0.3, 0), osim.Vec3(0, 0.5*np.pi, 0.5*np.pi))</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;helpers.addIMUFrame(model, <span class="stringliteral">&#39;femur_r&#39;</span>, </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    osim.Vec3(0, -0.2, 0.05), osim.Vec3(0, 0, 0.5*np.pi))</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;helpers.addIMUFrame(model, <span class="stringliteral">&#39;tibia_r&#39;</span>, osim.Vec3(0, -0.2, 0.05), </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    osim.Vec3(0, 0, 0.5*np.pi))</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"># Part 1c: Add IMU components to the model using the PhysicalOffsetFrames</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"># we just added to the model. We&#39;ll use the helper function addModelIMUs()</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"># included with OpenSenseUtilities.</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;imuFramePaths = osim.StdVectorString()</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;imuFramePaths.append(<span class="stringliteral">&#39;/bodyset/torso/torso_imu_offset&#39;</span>)</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;imuFramePaths.append(<span class="stringliteral">&#39;/bodyset/femur_r/femur_r_imu_offset&#39;</span>)</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;imuFramePaths.append(<span class="stringliteral">&#39;/bodyset/tibia_r/tibia_r_imu_offset&#39;</span>)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;osim.OpenSenseUtilities().addModelIMUs(model, imuFramePaths)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;model.initSystem()</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment"># Part 2a: Create a new MocoStudy.</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;study = osim.MocoStudy()</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"># Part 2b: Initialize the problem and set the model.</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;problem = study.updProblem()</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;problem.setModel(model)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"># Part 2c: Set bounds on the problem.</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"># problem.setTimeBounds(initial_bounds, final_bounds)</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"># problem.setStateInfo(path, trajectory_bounds, inital_bounds, final_bounds)</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"># All *_bounds arguments can be set to a range, [lower upper], or to a</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"># single value (equal lower and upper bounds). Empty brackets, [], indicate</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment"># using default bounds (if they exist). You may set multiple state infos at</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"># once using setStateInfoPattern():</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"># problem.setStateInfoPattern(pattern, trajectory_bounds, inital_bounds, ...</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment">#       final_bounds)</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment"># This function supports regular expressions in the &#39;pattern&#39; argument;</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment"># use &#39;.*&#39; to match any substring of the state/control path</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"># For example, the following will set all coordinate value state infos:</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"># problem.setStateInfoPattern(&#39;/path/to/states/.*/value&#39;, ...)</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"># Time bounds</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;problem.setTimeBounds(0, 1)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment"># Position bounds: the model should start in a squat and finish </span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment"># standing up.</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/hip_r/hip_flexion_r/value&#39;</span>,</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    [-2, 0.5], -2, 0)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/knee_r/knee_angle_r/value&#39;</span>, </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    [-2, 0], -2, 0)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/ankle_r/ankle_angle_r/value&#39;</span>, </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    [-0.5, 0.7], -0.5, 0)</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment"># Velocity bounds: all model coordinates should start and end at rest.</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;problem.setStateInfoPattern(<span class="stringliteral">&#39;/jointset/.*/speed&#39;</span>, [], 0, 0)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment"># Part 2d: Add a MocoControlGoal to the problem.</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;problem.addGoal(osim.MocoControlGoal(<span class="stringliteral">&#39;myeffort&#39;</span>))</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment"># Part 2e: Configure the solver.</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;solver = study.initCasADiSolver()</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;solver.set_num_mesh_intervals(25)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;solver.set_optim_constraint_tolerance(1e-4)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;solver.set_optim_convergence_tolerance(1e-4)</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="comment"># Part 2f: Solve! Write the solution to file, and visualize.</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    predictSolution = study.solve()</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    predictSolution.write(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    study.visualize(predictSolution)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment"># Part 3a: Load the prediction solution.</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;predictSolution = osim.MocoTrajectory(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment"># Part 3b: Compute the accelerometer signals using the analyzeVec3() free</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment"># function included with SimulationUtilities. These free functions can be</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment"># accessed in scripting by using the &#39;opensimSimulation&#39; prefix. </span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;outputPaths = osim.StdVectorString()</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;outputPaths.append(<span class="stringliteral">&#39;.*accelerometer_signal&#39;</span>)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;accelerometerSignals = osim.analyzeVec3(model,</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    predictSolution.exportToStatesTable(),</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    predictSolution.exportToControlsTable(),</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    outputPaths)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment"># Part 3c: Update the column labels of the accelerometer signals to match</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment"># the offset frame paths. This is necessary for the tracking goal we&#39;ll add</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment"># to the problem in Part 4. </span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;accelerometerSignals.setColumnLabels(imuFramePaths)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment"># Part 3d: Plot the synthetic acceleration signals.</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;helpers.plotAccelerationSignals(accelerometerSignals)</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;tracking = osim.MocoAccelerationTrackingGoal(<span class="stringliteral">&#39;acceleration_tracking&#39;</span>)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;tracking.setFramePaths(imuFramePaths)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;tracking.setAccelerationReference(accelerometerSignals)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;tracking.setGravityOffset(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;tracking.setExpressAccelerationsInTrackingFrames(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;problem.addGoal(tracking)</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment"># Part 4b: Reduce the control cost weight so that the tracking term will</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment"># dominate.</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;problem.updGoal(<span class="stringliteral">&#39;myeffort&#39;</span>).setWeight(0.001)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="comment"># Part 4c: Solve! Write the solution to file, and visualize.</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    trackingSolution = study.solve()</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    trackingSolution.write(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    study.visualize(trackingSolution)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;plot.mocoPlotTrajectory(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>, <span class="stringliteral">&#39;trackingSolution.sto&#39;</span>,</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="stringliteral">&#39;predict&#39;</span>, <span class="stringliteral">&#39;track&#39;</span>)</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160; </div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment"># Part 5b: Compare accelerations from tracking solution to the reference</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment"># accelerations.</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;trackingSolution = osim.MocoTrajectory(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;accelerometerSignalsTracking = osim.analyzeVec3(model, </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    trackingSolution.exportToStatesTable(), </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    trackingSolution.exportToControlsTable(), </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    outputPaths)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;accelerometerSignalsTracking.setColumnLabels(imuFramePaths)</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;helpers.plotAccelerationSignals(accelerometerSignals, </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                                accelerometerSignalsTracking)</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
